import sys
import paramiko
import json
import configparser
import os
import re
import subprocess
import time
sys.path.append('../')
from common.runlogger import *
from os import path
def getBIOSInfo(filepath):
    primaryHost = getenvdata('/','esx','hostname')[0]
    esxhostuser = getenvdata('/','esx','user')[0]
    esxHostRootPwd = getenvdata('/','esx','password')[0]
    ssh = sshConnection(primaryHost,esxhostuser,esxHostRootPwd)
    command1 = "vsish -e get /hardware/bios/biosInfo"
    type11_server = False
    stdin, stdout, stderr = ssh.exec_command(command1)
    list = []
    while True:
        nextline = stdout.readline()
        if nextline == '':
            break
        list.append(nextline)
    i = 0
    certinfo = filepath+"/certInfo.properties"
    certinfo_file = open(certinfo,'a+',encoding = 'utf-8')
    while i < len(list):
        if "BIOS Vendor" in list[i]:
            BIOS_vendor = str(list[i].rstrip("\n")).split(':')[1]
            certinfo_file.write((str(list[i].lstrip())).replace(':','='))
        i = i+1
    command2 = "vsish -e get /hardware/bios/dmiInfo"
    stdin, stdout, stderr = ssh.exec_command(command2)
    list1 = []
    while True:
        nextline = stdout.readline()
        if nextline == '':
            break
        list1.append(nextline)
    j = 0
    isfamily = "false"
    while j < len(list1):
        if "Version" in list1[j]:
            version = str(list1[j].rstrip("\n")).split(':')[1]
            if version == "":
                certinfo_file.write("Version=NA\n")
            else:
                certinfo_file.write((str(list1[j].lstrip())).replace(':','='))
        elif "SKU Number" in list1[j]:
            sku = str(list1[j].rstrip("\n")).split(':')[1]
            if sku == "":
                certinfo_file.write("SKU Number=NA\n")
            else:
                certinfo_file.write((str(list1[j].lstrip())).replace(':','='))
        elif "Product Name:" in list1[j]:
            generation = list1[j].split(':')[1]
            print(generation)
            if "Gen11" in generation:
                type11_server = True
                print("This is Gen11 server")
        if "Family" in list1[j]:
            isfamily = "True"
            family = str(list1[j].rstrip("\n")).split(':')[1]
            if family == "":
                certinfo_file.write("Family=NA\n")
            else:
                certinfo_file.write((str(list1[j].lstrip())).replace(':','='))
        j = j+1
    count = 0
    if isfamily == "True":
        with open('/certs/common/vendor_family.json') as json_data:
            data = json.load(json_data)
        for li in data['Vendor_Family']['vendor_list']:
            for k,v in li.items():
                if((BIOS_vendor in k) and (family in v)):
                    IncludeBIOSreleaseYes="True"
                    count = count+1
                elif count==0:
                   IncludeBIOSreleaseYes="False"
    else:
        IncludeBIOSreleaseYes="False"	
    if IncludeBIOSreleaseYes=="True":
        certinfo_file.write("IncludeBIOSreleaseYes=True\n")
    else:
        certinfo_file.write("IncludeBIOSreleaseYes=False\n")
    ssh.close()
    certinfo_file.close()
    return type11_server

def fetch_ROM_family(filepath):
    primaryHost = getenvdata('/','esx','hostname')[0]
    esxhostuser = getenvdata('/','esx','user')[0]
    esxHostRootPwd = getenvdata('/','esx','password')[0]
    ssh = sshConnection(primaryHost,esxhostuser,esxHostRootPwd)
    command = "vsish -e ls /hardware/bios/oemStrings | wc -l"
    stdin, stdout, stderr = ssh.exec_command(command)
    oemstring_count = stdout.readline()
    certinfo = filepath+"/certInfo.properties"
    certinfo_file = open(certinfo,'a+',encoding = 'utf-8')
    while int(oemstring_count)>=1:
        command1 = "vsish -e get /hardware/bios/oemStrings/"+str(oemstring_count)
        stdin, oem_string, stderr = ssh.exec_command(command1)
        oem_string_str = oem_string.readline()
        if "Rom Family:" in oem_string_str:
                rom_family_version = oem_string_str.split(':')[1]
                print(rom_family_version)
                rom_family = oem_string_str.lstrip().replace(':','=')
                rom_family_processed = re.sub(r"(\=)\s+", "=", rom_family)
                print(rom_family_processed)
                certinfo_file.write(rom_family_processed)
        oemstring_count = int(oemstring_count) - 1
    certinfo_file.close()

def sshConnection(esx_host,esx_user,esx_password):
    ssh = paramiko.SSHClient()
    ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
    ssh.connect(hostname=esx_host, username=esx_user, password=esx_password)
    return ssh
def getenvdata(dir, hosttype,key):
    with open(dir+'runlist.json') as json_data:
        data = json.load(json_data)
        return  [ li[key] for li in data['environment']['hosts'] if li['hosttype'] == hosttype]
def main():
    type11_server = getBIOSInfo(sys.argv[1])
    if type11_server == True:
        fetch_ROM_family(sys.argv[1])
if __name__== '__main__':
    main()
