import sys
import paramiko
import json
import configparser
import os
import subprocess
import time
import re
sys.path.append('../common')
from runlogger import *

def runTest(test_name,log_dir,dir,num_reboots):
    try:
        esx_host = getenvdata(dir,'esx','hostname')[0]
        esx_user = getenvdata(dir,'esx','user')[0]
        esx_password = getenvdata(dir,'esx','password')[0]

        resultfile = open(log_dir+'/.result', 'w')
        testresult = False
        ssh = sshConnection(esx_host,esx_user,esx_password,resultfile)
        command = "cat /scratch/vmware/loadESX/loadESXPlatformQual.conf"
        stdin, stdout, stderr = ssh.exec_command(command)
        if stdout.channel.recv_exit_status() == 0:
            lst = []
            while True:
                nextline = stdout.readline()
                if nextline == '':
                    break
                logging.info(nextline)
                lst.append(nextline)
            str1 = ''.join(lst)
            m = re.search('"testResult": "Test seq. completed."' , str1) and re.search('"numBoots": '+num_reboots , str1)
            if m:
                logging.info("Host has completed "+num_reboots+" Quick Boots successfully \n")
                testresult = True
            else:
                logging.error("Host has not completed "+num_reboots+" Quick Boots \n")
                testresult = False
        else:
            logging.error("loadESXPlatformQual.conf file doesn't exist, Quick boot Tests has not been run")
            testResult = False
            
        if testresult == True:
            logging.info('Quick Boot platform qualification tests passed')
            resultfile.write('Passed')
        else:
            logging.error('Quick Boot platform qualification tests failed')
            resultfile.write('Failed')
        resultfile.close
        ssh.close()
    except Exception as e:
        logging.error("Error: " +str(e))
        resultfile.write("Failed")
        resultfile.close
        ssh.close()
        sys.exit(1)

def sshConnection(esx_host,esx_user,esx_password,resultfile):
    try:
        logging.info("sshConnection..")
        ssh = paramiko.SSHClient()
        ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
        ssh.connect(hostname=esx_host, username=esx_user, password=esx_password)
        return ssh
    except Exception as e:
        logging.info("Error: " +str(e))
        resultfile.write("Failed")
        resultfile.close
        ssh.close()
        sys.exit(1)

def getenvdata(dir, hosttype,key):
      with open(dir+'runlist.json') as json_data:
          data = json.load(json_data)
          return  [ li[key] for li in data['environment']['hosts'] if li['hosttype'] == hosttype]

def main():
    runlogger(sys.argv[2])
    runTest(sys.argv[1],sys.argv[2],'/',sys.argv[3])

if __name__== '__main__':
    main()
